#include <Wire.h>

#define uint8_t unsigned char

#define MODE0   0x00  //Channel0 = AIN0;
                      //Channel1 = AIN1;
                      //Channel2 = AIN2;
                      //Channel3 = AIN3;
#define MODE1   0x10  //Channel0 = AIN3-AIN0;
                      //Channel1 = AIN3-AIN1
                      //Channel2 = AIN3-AIN2;
#define MODE2   0x20  //Channel0 = AIN0;
                      //Channel1 = AIN1;
                      //Channel2 = AIN3-AIN2;
#define MODE3   0x30  //Channel0 = AIN1-AIN0;
                      //Channel1 = AIN3-AIN2;
            
#define CHNL0   0   //Using Channel0
#define CHNL1   1   //Using Channel1
#define CHNL2   2   //Using Channel2
#define CHNL3   3   //Using Channel3

#define DAouputEn 0x40//0x50 or 0x60 or 0x70 is also ok!

#define PCF8591Add (0x90 >> 1)

uint8_t AD_vaule[4]={0};

void setup() {
  // put your setup code here, to run once:
  Wire.begin();
  Serial.begin(9600);
  Serial.println("I2C Scanner started");
  
}

void loop() {
  // put your main code here, to run repeatedly:

 /******Read the analog quantity of channel 0******/
  Wire.beginTransmission(PCF8591Add); //Address of sending slave
  Wire.write(MODE0|CHNL1);            //Send control word
  Wire.endTransmission();             //ending signal
  Wire.requestFrom(PCF8591Add, 1);    //Request to read one byte
  AD_vaule[0] = Wire.read();          //The byte read is stored in the array
  
 /******Read the analog quantity of channel 1******/ 
  Wire.beginTransmission(PCF8591Add);
  Wire.write(MODE0|CHNL2);
  Wire.endTransmission();
  Wire.requestFrom(PCF8591Add, 1);
  AD_vaule[1] = Wire.read();

/******Read the analog quantity of channel 2******/
  Wire.beginTransmission(PCF8591Add);
  Wire.write(MODE0|CHNL3);
  Wire.endTransmission();
  Wire.requestFrom(PCF8591Add, 1);
  AD_vaule[2] = Wire.read();
  
/******Read the analog quantity of channel 3******/
  Wire.beginTransmission(PCF8591Add);
  Wire.write(MODE0|CHNL0);
  Wire.endTransmission();
  Wire.requestFrom(PCF8591Add, 1);
  AD_vaule[3] = Wire.read();

/*******The simulated value collected by the third channel is output through Aout*******/
  Wire.beginTransmission(PCF8591Add);
  Wire.write(DAouputEn);              //Analog output is allowed without adding a single end
  Wire.write(AD_vaule[3]);            //Output the AD value of channel 3
  Wire.endTransmission();

 /******The signals collected by the four channels are displayed through the serial port******/
  Serial.print("Channel0:");
  Serial.println(AD_vaule[0]);
  Serial.print("Channel1:");
  Serial.println(AD_vaule[1]);
  Serial.print("Channel2:");
  Serial.println(AD_vaule[2]);
  Serial.print("Channel3:");
  Serial.println(AD_vaule[3]);
  Serial.println("");

  delay(1000);
  
}
