#include "PCF8591.h"

/******************************************************************************
function:	PCF8591_init
parameter: 

Info:Initialize the I2C
******************************************************************************/
int PCF8591_init()
{
    wiringPiSetup();
    int fd = wiringPiI2CSetup(PCF8591Add);
    return fd;
}

/******************************************************************************
function:	PCF8591_Write
parameter: 
    fd: File descriptor for Linux
    data:  Send control words to slave machine
Info:Write one byte
******************************************************************************/
void PCF8591_Write(int fd,int data)
{
    wiringPiI2CWrite (fd,data) ;
}


/******************************************************************************
function:	PCF8591_Aout
parameter: 
    fd: File descriptor for Linux
    reg:   Send control words to slave machine
    data:  Set voltage
Info:DA output
******************************************************************************/
void PCF8591_Aout(int fd,int reg,int data)
{
    wiringPiI2CWriteReg8 (fd, reg, data) ;
}

/******************************************************************************
function:	PCF8591_Read
parameter: 
    fd: File descriptor for Linux
Info:Read the AD value of one byte
******************************************************************************/
int PCF8591_Read(int fd)
{   
    int data;
    data = wiringPiI2CRead (fd);
    return data;
}
